Channel(T) -

# abstract class Channel(T)

- Channel(T)
- Reference
- Object

## Overview

A `Channel` enables concurrent communication between fibers.

They allow communicating data between fibers without sharing memory and without having to worry about locks, semaphores or other special structures.

    channel = Channel(Int32).new

    spawn do
      channel.send(0)
      channel.send(1)
    end

    channel.receive # => 0
    channel.receive # => 1

## Direct Known Subclasses

- Channel::Buffered(T)
- Channel::Unbuffered(T)

## Defined in:

## Constructors

- .new(capacity) : Channel::Buffered(T)
- .new : Channel::Unbuffered(T)

## Class Method Summary

- .receive_first(channels : Tuple | Array)
- .receive_first(*channels)
- .select(ops : Tuple | Array, has_else = false)
- .select(*ops : SelectAction)
- .send_first(value, channels : Tuple | Array)
- .send_first(value, *channels)

## Instance Method Summary

- #close
- #closed?
- #inspect(io : IO) : Nil
- #pretty_print(pp)
- #receive

  Receives a value from the channel.

- #receive?

  Receives a value from the channel.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(capacity) : Channel::Buffered(T) #
def self.new : Channel::Unbuffered(T) #

## Class Method Detail

def self.receive_first(channels : Tuple | Array) #
def self.receive_first(*channels) #
def self.select(ops : Tuple | Array, has_else = false) #
def self.select(*ops : SelectAction) #
def self.send_first(value, channels : Tuple | Array) #
def self.send_first(value, *channels) #

## Instance Method Detail

def close #
def closed? #
def inspect(io : IO) : Nil #
def pretty_print(pp) #
def receive #

Receives a value from the channel. If there is a value waiting, it is returned immediately. Otherwise, this method blocks until a value is sent to the channel.

Raises `ClosedError` if the channel is closed or closes while waiting for receive.

    channel = Channel(Int32).new
    channel.send(1)
    channel.receive # => 1

def receive? #

Receives a value from the channel. If there is a value waiting, it is returned immediately. Otherwise, this method blocks until a value is sent to the channel.

Returns `nil` if the channel is closed or closes while waiting for receive.